//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%4AB7A15301CE.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%4AB7A15301CE.cm

//## begin module%4AB7A15301CE.cp preserve=no
//## end module%4AB7A15301CE.cp

//## Module: PlotCommand%4AB7A15301CE; Package specification
//## Subsystem: XSPlot::Plot%3D625E94026B
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSPlot/Plot/PlotCommand.h

#ifndef PLOTCOMMAND_H
#define PLOTCOMMAND_H 1

//## begin module%4AB7A15301CE.additionalIncludes preserve=no
//## end module%4AB7A15301CE.additionalIncludes

//## begin module%4AB7A15301CE.includes preserve=yes
#include <xsTypes.h>
#include <XSPlot/Plot/PlotTypes.h>
//## end module%4AB7A15301CE.includes

//## begin module%4AB7A15301CE.declarations preserve=no
//## end module%4AB7A15301CE.declarations

//## begin module%4AB7A15301CE.additionalDeclarations preserve=yes
class PlotGroupCreator;
class PlotGroup;
class PlotSettings;
//## end module%4AB7A15301CE.additionalDeclarations


//## begin PlotCommand%4AB7A48D003B.preface preserve=yes
//## end PlotCommand%4AB7A48D003B.preface

//## Class: PlotCommand%4AB7A48D003B
//## Category: XSPlot::Plot%3D625E6A0065
//## Subsystem: XSPlot::Plot%3D625E94026B
//## Persistence: Transient
//## Cardinality/Multiplicity: n



class PlotCommand 
{
  //## begin PlotCommand%4AB7A48D003B.initialDeclarations preserve=yes
  //## end PlotCommand%4AB7A48D003B.initialDeclarations

  public:
    //## Destructor (generated)
      virtual ~PlotCommand();


    //## Other Operations (specified)
      //## Operation: commonInit%4ACDFAE10101
      //	Actions to be performed once for all PlotCommand objects
      //	at the start of each makePlot run.
      static void commonInit ();

      //## Operation: verifyState%4ACDFB9102E5
      //	For each PlotCommand object, verifies that the necessary
      //	data and/or models are currently loaded, throws if not.
      void verifyState () const;

      //## Operation: getRangeSettings%4ADCBD9B0361
      const PlotRange& getRangeSettings () const;

      //## Operation: processPlotGroups%4ADCD6E4013B
      //	Template pattern method (calling private virtual
      //	functions) for performing command-specific operations on
      //	PlotGroup data (ie. calculations and range setting).
      void processPlotGroups (std::vector<PlotGroup*>& plotGroups, const PlotSettings& settings);

      //## Operation: makeLabels%4B01BC0C01F2
      //	If not overridden, this does nothing.
      virtual void makeLabels (const PlotSettings& settings, StandardLabels& labels) const;

      //## Operation: requestNewXoption%4B3A1C8F035F
      //	Some PlotCommands may need to enforce an xOption mode
      //	that differs from the user's current setting.  They can
      //	override this to request a change by returning TRUE, and
      //	by setting the newOption arg with the new value.  If
      //	this returns FALSE, newOption will not be modified
      //	(which is the default function behavior). Note that this
      //	does not actually modify PlotSetting's xOption, it
      //	merely requests.
      virtual bool requestNewXoption (const PlotSettings& settings, XaxisMode& newOption) const;

      //## Operation: processAdditionalParams%4B3A780E0021
      //	This provides a way of passing command-line arguments to
      //	the subset of PlotCommand classes which take them.  If
      //	not overriden this does nothing.
      virtual void processAdditionalParams (const StringArray& args, const IntegerArray& argIndices);

      //## Operation: makePlotGroups%4B6336D70114
      //	PlotCommand subclasses will determine whether to create
      //	plot groups from the donated plot group vector (coming
      //	from the previous plot) OR from scratch by calling their
      //	own PlotGroupCreator strategy.  Naturally it will always
      //	do the latter if the donated vector is empty.
      virtual std::vector<PlotGroup*> makePlotGroups (const PlotSettings& settings, const std::vector<const PlotGroup*>& donatedPlotGroups);

    //## Get and Set Operations for Class Attributes (generated)

      //## Attribute: cmdName%4AB7A7EE0199
      const string& cmdName () const;

      //## Attribute: doesTakeParameters%4B181D0F004E
      //	True if the command may take additional (optional)
      //	arguments from the command line.
      bool doesTakeParameters () const;

      //## Attribute: isDivisibleByArea%4AD64201001F
      //	Flag is true for commands which are affected by the
      //	setplot area setting.
      bool isDivisibleByArea () const;

      //## Attribute: addCompLevel%4ADC8D0402A8
      //	Determines the level of add component display for this
      //	command:  0 = not applicable (never display), 1 =
      //	display add comp if user chooses (w/ setplot add), 2 =
      //	display folded add comp if user chooses, 3 = display
      //	added comp regardless of user's selection, 4 = display
      //	folded add comp regardless of user's selection.
      int addCompLevel () const;

      //## Attribute: isBackgroundApplicable%4ADC8D6B02AD
      bool isBackgroundApplicable () const;

      //## Attribute: isLineIDApplicable%4B5F44B30267
      bool isLineIDApplicable () const;

      //## Attribute: isPlotGroupDonor%4B6334920272
      //	A plot group donor is a PlotCommand which might
      //	influence the succeeding PlotCommand in a multi-pane
      //	plot.  An example being "data ratio" or "icounts ratio",
      //	which produce different behavior in the ratio plot.  In
      //	this situation, the second plot will want to make use of
      //	the first plot's plot groups.
      bool isPlotGroupDonor () const;

      //## Attribute: isContour%4B4CAFD10285
      bool isContour () const;

      //## Attribute: styleMap%4AD5F9760284
      const std::map<PlotStyle::VectorCategory,PlotAttributes>& styleMap () const;

      //## Attribute: standardModelStyle%4AD61C2303D3
      //	Stores in a single place the default model line style
      //	from which all subclasses using model PlotVectors may
      //	set their  line-style attribute.  If a general change in
      //	appearance is decided upon, it need only be modified
      //	here.
      static PlotStyle::LineStyle standardModelStyle ();

      //## Attribute: standardDataStyle%4AD61D7A003B
      //	Stores in a single place the default data symbol style
      //	from which all subclasses using data PlotVectors may set
      //	their  symbol-style attribute.  If a general change in
      //	appearance is decided upon, it need only be modified
      //	here.
      static PlotStyle::Symbol standardDataStyle ();

    //## Get and Set Operations for Associations (generated)

      //## Association: XSPlot::Plot::<unnamed>%4AB7DAE30052
      //## Role: PlotCommand::plotGroupStrategy%4AB7DAE4009E
      PlotGroupCreator* plotGroupStrategy () const;

    // Additional Public Declarations
      //## begin PlotCommand%4AB7A48D003B.public preserve=yes
      //## end PlotCommand%4AB7A48D003B.public

  protected:
    //## Constructors (specified)
      //## Operation: PlotCommand%4AB7A793021B
      PlotCommand (const string& cmdName, PlotGroupCreator* plotGroupStrategy);


    //## Other Operations (specified)
      //## Operation: setStyleMap%4AD5FAF101AD
      void setStyleMap (PlotStyle::VectorCategory category, const PlotAttributes& attributes);

      //## Operation: doesTakeParameters%4B181E4201FC
      void doesTakeParameters (bool flag);

      //## Operation: isDivisibleByArea%4AD6442702D8
      void isDivisibleByArea (bool value);

      //## Operation: addCompLevel%4ADC8E1A0019
      void addCompLevel (int level);

      //## Operation: isBackgroundApplicable%4ADC8E7300FD
      void isBackgroundApplicable (bool value);

      //## Operation: isLineIDApplicable%4B5F45390319
      void isLineIDApplicable (bool value);

      //## Operation: isPlotGroupDonor%4B6336110255
      void isPlotGroupDonor (bool value);

      //## Operation: isContour%4B4CB0190398
      void isContour (bool value);

      //## Operation: processSuperAndSub%4B573CAA0293
      //	Convert '^' and '_' super and subscript symbols in
      //	parameter labels, originally only used by Contour
      //	Plot<T>.  This is borderline PLT specific, but resides
      //	here since it's more natural to perform the conversions
      //	when the labels are originally set.
      static string processSuperAndSub (const string& inString);

    //## Get and Set Operations for Class Attributes (generated)

      //## Attribute: isDataRequired%4ACDF85801F4
      bool isDataRequired () const;
      void isDataRequired (bool value);

      //## Attribute: isActiveModelRequired%4ACDF8900329
      bool isActiveModelRequired () const;
      void isActiveModelRequired (bool value);

      //## Attribute: rangeSettings%4ADCBCB60166
      PlotRange& rangeSettings ();

      //## Attribute: dataStatus%4ACDF9610125
      //	Updated at the start of each makePlot call, set to true
      //	if any spectra are loaded.
      static bool dataStatus ();

      //## Attribute: activeModelStatus%4ACDFA400384
      //	Updated at the start of each makePlot call, set to true
      //	if any active models are found.
      static bool activeModelStatus ();

    // Additional Protected Declarations
      //## begin PlotCommand%4AB7A48D003B.protected preserve=yes
      //## end PlotCommand%4AB7A48D003B.protected

  private:
    //## Constructors (generated)
      PlotCommand(const PlotCommand &right);

    //## Assignment Operation (generated)
      PlotCommand & operator=(const PlotCommand &right);


    //## Other Operations (specified)
      //## Operation: manipulate%4ACCDD2003B7
      //	Once the raw data has been gathered into PlotGroup
      //	objects, this is the function that performs the various
      //	mathematical operations specific to each PlotCommand
      //	subclass.
      virtual void manipulate (std::vector<PlotGroup*>& plotGroups, const PlotSettings& settings);

      //## Operation: setRanges%4ADCD90F006D
      //	Determines plot-time range settings based on current
      //	setplot settings and PlotGroup data.
      virtual void setRanges (std::vector<PlotGroup*>& plotGroups, const PlotSettings& settings) = 0;

    // Additional Private Declarations
      //## begin PlotCommand%4AB7A48D003B.private preserve=yes
      //## end PlotCommand%4AB7A48D003B.private

  private: //## implementation
    // Data Members for Class Attributes

      //## begin PlotCommand::cmdName%4AB7A7EE0199.attr preserve=no  public: string {UC} 
      const string m_cmdName;
      //## end PlotCommand::cmdName%4AB7A7EE0199.attr

      //## Attribute: plotGroupStrategy%4AC52053039F
      //## begin PlotCommand::plotGroupStrategy%4AC52053039F.attr preserve=no  public: PlotGroupCreator* const {U} 
      PlotGroupCreator* const m_plotGroupStrategy;
      //## end PlotCommand::plotGroupStrategy%4AC52053039F.attr

      //## begin PlotCommand::doesTakeParameters%4B181D0F004E.attr preserve=no  public: bool {U} 
      bool m_doesTakeParameters;
      //## end PlotCommand::doesTakeParameters%4B181D0F004E.attr

      //## begin PlotCommand::isDataRequired%4ACDF85801F4.attr preserve=no  protected: bool {U} 
      bool m_isDataRequired;
      //## end PlotCommand::isDataRequired%4ACDF85801F4.attr

      //## begin PlotCommand::isActiveModelRequired%4ACDF8900329.attr preserve=no  protected: bool {U} 
      bool m_isActiveModelRequired;
      //## end PlotCommand::isActiveModelRequired%4ACDF8900329.attr

      //## begin PlotCommand::isDivisibleByArea%4AD64201001F.attr preserve=no  public: bool {U} 
      bool m_isDivisibleByArea;
      //## end PlotCommand::isDivisibleByArea%4AD64201001F.attr

      //## begin PlotCommand::addCompLevel%4ADC8D0402A8.attr preserve=no  public: int {U} 
      int m_addCompLevel;
      //## end PlotCommand::addCompLevel%4ADC8D0402A8.attr

      //## begin PlotCommand::isBackgroundApplicable%4ADC8D6B02AD.attr preserve=no  public: bool {U} 
      bool m_isBackgroundApplicable;
      //## end PlotCommand::isBackgroundApplicable%4ADC8D6B02AD.attr

      //## begin PlotCommand::isLineIDApplicable%4B5F44B30267.attr preserve=no  public: bool {U} 
      bool m_isLineIDApplicable;
      //## end PlotCommand::isLineIDApplicable%4B5F44B30267.attr

      //## begin PlotCommand::isPlotGroupDonor%4B6334920272.attr preserve=no  public: bool {U} 
      bool m_isPlotGroupDonor;
      //## end PlotCommand::isPlotGroupDonor%4B6334920272.attr

      //## begin PlotCommand::isContour%4B4CAFD10285.attr preserve=no  public: bool {U} 
      bool m_isContour;
      //## end PlotCommand::isContour%4B4CAFD10285.attr

      //## begin PlotCommand::styleMap%4AD5F9760284.attr preserve=no  public: std::map<PlotStyle::VectorCategory,PlotAttributes> {U} 
      std::map<PlotStyle::VectorCategory,PlotAttributes> m_styleMap;
      //## end PlotCommand::styleMap%4AD5F9760284.attr

      //## begin PlotCommand::rangeSettings%4ADCBCB60166.attr preserve=no  protected: PlotRange {U} 
      PlotRange m_rangeSettings;
      //## end PlotCommand::rangeSettings%4ADCBCB60166.attr

      //## begin PlotCommand::dataStatus%4ACDF9610125.attr preserve=no  protected: static bool {U} false
      static bool s_dataStatus;
      //## end PlotCommand::dataStatus%4ACDF9610125.attr

      //## begin PlotCommand::activeModelStatus%4ACDFA400384.attr preserve=no  protected: static bool {U} false
      static bool s_activeModelStatus;
      //## end PlotCommand::activeModelStatus%4ACDFA400384.attr

      //## begin PlotCommand::standardModelStyle%4AD61C2303D3.attr preserve=no  public: static PlotStyle::LineStyle {UC} PlotStyle::SOLID
      static const PlotStyle::LineStyle s_standardModelStyle;
      //## end PlotCommand::standardModelStyle%4AD61C2303D3.attr

      //## begin PlotCommand::standardDataStyle%4AD61D7A003B.attr preserve=no  public: static PlotStyle::Symbol {UC} PlotStyle::DOT
      static const PlotStyle::Symbol s_standardDataStyle;
      //## end PlotCommand::standardDataStyle%4AD61D7A003B.attr

    // Data Members for Associations

    // Additional Implementation Declarations
      //## begin PlotCommand%4AB7A48D003B.implementation preserve=yes
      //## end PlotCommand%4AB7A48D003B.implementation

};

//## begin PlotCommand%4AB7A48D003B.postscript preserve=yes
//## end PlotCommand%4AB7A48D003B.postscript

// Class PlotCommand 


//## Other Operations (inline)
inline void PlotCommand::doesTakeParameters (bool flag)
{
  //## begin PlotCommand::doesTakeParameters%4B181E4201FC.body preserve=yes
   m_doesTakeParameters = flag;
  //## end PlotCommand::doesTakeParameters%4B181E4201FC.body
}

inline void PlotCommand::isDivisibleByArea (bool value)
{
  //## begin PlotCommand::isDivisibleByArea%4AD6442702D8.body preserve=yes
   m_isDivisibleByArea = value;
  //## end PlotCommand::isDivisibleByArea%4AD6442702D8.body
}

inline void PlotCommand::addCompLevel (int level)
{
  //## begin PlotCommand::addCompLevel%4ADC8E1A0019.body preserve=yes
   m_addCompLevel = level;
  //## end PlotCommand::addCompLevel%4ADC8E1A0019.body
}

inline void PlotCommand::isBackgroundApplicable (bool value)
{
  //## begin PlotCommand::isBackgroundApplicable%4ADC8E7300FD.body preserve=yes
   m_isBackgroundApplicable = value;
  //## end PlotCommand::isBackgroundApplicable%4ADC8E7300FD.body
}

inline void PlotCommand::isLineIDApplicable (bool value)
{
  //## begin PlotCommand::isLineIDApplicable%4B5F45390319.body preserve=yes
   m_isLineIDApplicable = value;
  //## end PlotCommand::isLineIDApplicable%4B5F45390319.body
}

inline void PlotCommand::isPlotGroupDonor (bool value)
{
  //## begin PlotCommand::isPlotGroupDonor%4B6336110255.body preserve=yes
   m_isPlotGroupDonor = value;
  //## end PlotCommand::isPlotGroupDonor%4B6336110255.body
}

inline void PlotCommand::isContour (bool value)
{
  //## begin PlotCommand::isContour%4B4CB0190398.body preserve=yes
   m_isContour = value;
  //## end PlotCommand::isContour%4B4CB0190398.body
}

inline const PlotRange& PlotCommand::getRangeSettings () const
{
  //## begin PlotCommand::getRangeSettings%4ADCBD9B0361.body preserve=yes
   return m_rangeSettings;
  //## end PlotCommand::getRangeSettings%4ADCBD9B0361.body
}

//## Get and Set Operations for Class Attributes (inline)

inline const string& PlotCommand::cmdName () const
{
  //## begin PlotCommand::cmdName%4AB7A7EE0199.get preserve=no
  return m_cmdName;
  //## end PlotCommand::cmdName%4AB7A7EE0199.get
}

inline bool PlotCommand::doesTakeParameters () const
{
  //## begin PlotCommand::doesTakeParameters%4B181D0F004E.get preserve=no
  return m_doesTakeParameters;
  //## end PlotCommand::doesTakeParameters%4B181D0F004E.get
}

inline bool PlotCommand::isDataRequired () const
{
  //## begin PlotCommand::isDataRequired%4ACDF85801F4.get preserve=no
  return m_isDataRequired;
  //## end PlotCommand::isDataRequired%4ACDF85801F4.get
}

inline void PlotCommand::isDataRequired (bool value)
{
  //## begin PlotCommand::isDataRequired%4ACDF85801F4.set preserve=no
  m_isDataRequired = value;
  //## end PlotCommand::isDataRequired%4ACDF85801F4.set
}

inline bool PlotCommand::isActiveModelRequired () const
{
  //## begin PlotCommand::isActiveModelRequired%4ACDF8900329.get preserve=no
  return m_isActiveModelRequired;
  //## end PlotCommand::isActiveModelRequired%4ACDF8900329.get
}

inline void PlotCommand::isActiveModelRequired (bool value)
{
  //## begin PlotCommand::isActiveModelRequired%4ACDF8900329.set preserve=no
  m_isActiveModelRequired = value;
  //## end PlotCommand::isActiveModelRequired%4ACDF8900329.set
}

inline bool PlotCommand::isDivisibleByArea () const
{
  //## begin PlotCommand::isDivisibleByArea%4AD64201001F.get preserve=no
  return m_isDivisibleByArea;
  //## end PlotCommand::isDivisibleByArea%4AD64201001F.get
}

inline int PlotCommand::addCompLevel () const
{
  //## begin PlotCommand::addCompLevel%4ADC8D0402A8.get preserve=no
  return m_addCompLevel;
  //## end PlotCommand::addCompLevel%4ADC8D0402A8.get
}

inline bool PlotCommand::isBackgroundApplicable () const
{
  //## begin PlotCommand::isBackgroundApplicable%4ADC8D6B02AD.get preserve=no
  return m_isBackgroundApplicable;
  //## end PlotCommand::isBackgroundApplicable%4ADC8D6B02AD.get
}

inline bool PlotCommand::isLineIDApplicable () const
{
  //## begin PlotCommand::isLineIDApplicable%4B5F44B30267.get preserve=no
  return m_isLineIDApplicable;
  //## end PlotCommand::isLineIDApplicable%4B5F44B30267.get
}

inline bool PlotCommand::isPlotGroupDonor () const
{
  //## begin PlotCommand::isPlotGroupDonor%4B6334920272.get preserve=no
  return m_isPlotGroupDonor;
  //## end PlotCommand::isPlotGroupDonor%4B6334920272.get
}

inline bool PlotCommand::isContour () const
{
  //## begin PlotCommand::isContour%4B4CAFD10285.get preserve=no
  return m_isContour;
  //## end PlotCommand::isContour%4B4CAFD10285.get
}

inline const std::map<PlotStyle::VectorCategory,PlotAttributes>& PlotCommand::styleMap () const
{
  //## begin PlotCommand::styleMap%4AD5F9760284.get preserve=no
  return m_styleMap;
  //## end PlotCommand::styleMap%4AD5F9760284.get
}

inline PlotRange& PlotCommand::rangeSettings ()
{
  //## begin PlotCommand::rangeSettings%4ADCBCB60166.get preserve=no
  return m_rangeSettings;
  //## end PlotCommand::rangeSettings%4ADCBCB60166.get
}

inline bool PlotCommand::dataStatus ()
{
  //## begin PlotCommand::dataStatus%4ACDF9610125.get preserve=no
  return s_dataStatus;
  //## end PlotCommand::dataStatus%4ACDF9610125.get
}

inline bool PlotCommand::activeModelStatus ()
{
  //## begin PlotCommand::activeModelStatus%4ACDFA400384.get preserve=no
  return s_activeModelStatus;
  //## end PlotCommand::activeModelStatus%4ACDFA400384.get
}

inline PlotStyle::LineStyle PlotCommand::standardModelStyle ()
{
  //## begin PlotCommand::standardModelStyle%4AD61C2303D3.get preserve=no
  return s_standardModelStyle;
  //## end PlotCommand::standardModelStyle%4AD61C2303D3.get
}

inline PlotStyle::Symbol PlotCommand::standardDataStyle ()
{
  //## begin PlotCommand::standardDataStyle%4AD61D7A003B.get preserve=no
  return s_standardDataStyle;
  //## end PlotCommand::standardDataStyle%4AD61D7A003B.get
}

//## Get and Set Operations for Associations (inline)

inline PlotGroupCreator* PlotCommand::plotGroupStrategy () const
{
  //## begin PlotCommand::plotGroupStrategy%4AB7DAE4009E.get preserve=no
  return m_plotGroupStrategy;
  //## end PlotCommand::plotGroupStrategy%4AB7DAE4009E.get
}

//## begin module%4AB7A15301CE.epilog preserve=yes
//## end module%4AB7A15301CE.epilog


#endif
